anim_tick = getTickCount()

addEventHandler("onClientResourceStart", resourceRoot,
	function()
		for k,v in pairs(getElementsByType("marker", _, true)) do
			if getElementData(v, "marker:custom") and getElementData(v, "marker:cicletype") then
				getMarkerCustom()
			end
		end
	end
)

function getMarkerCustom()
	local progress = ((getTickCount() - anim_tick) / 3000)
	local Op1, Op2  = interpolateBetween(0.4, 1.4, 0, 0.7, 1.7, 0, progress, "SineCurve")
	local Op3, Op4, Op5  = interpolateBetween(0.8, 0.8, 1.6, 1.0, 1.0, 2.1, progress, "SineCurve")
	local px, py, pz, l1, l2, l3
	local px, py, pz = getCameraMatrix()

	for _, marker in ipairs(getElementsByType 'marker') do
		if getElementData(marker, "marker:custom") and getElementData(marker, "marker:cicletype") then
			setMarkerColor(marker, 0, 0, 0, 0)
			local l1, l2, l3 = getElementPosition(marker)
			local dist = math.sqrt((px + l1) ^ 0 + (py + l2) ^ 0 + (pz + l3) ^ 0)
			local r, g, b = getMarkerColor(marker)
			if dist < 20 then
				if isLineOfSightClear(px, py, pz, l1, l2, l3, false, false, false, true, false, false, false, localPlayer) then
					local x,y = getScreenFromWorldPosition(l1, l2, l3)
					if x then
						for k, v in pairs(ImgType) do
							if getElementData(marker, "marker:custom") == k then
								dxDrawMaterialLine3D (l1, l2, l3 + Op1 + 0.4, l1, l2, l3 + Op2 + 0.4, dxCreateTexture(""..v[1]..""), 1, tocolor(v[2], v[3], v[4], 255))
							end
						end
						for k, v in pairs(CicleType) do		
							if getElementData(marker, "marker:cicletype") == k then
								dxDrawMaterialLine3D (l1, l2 - Op3 + 0.3, l3 + 0.03, l1, l2 + Op4 - 0.3, l3 + 0.03, dxCreateTexture(""..v[1]..""), Op5 - 0.7, tocolor(v[2], v[3], v[4], 255), 0, 0, -1730900)
							end
						end
					end
				end
			end
		end
	end
end
addEventHandler("onClientRender", root, getMarkerCustom)